//  **** BEGIN LICENSE BLOCK ****
//  Copyright(c) 2005-2006 Adam Judson
//
//
//  PhotoMap
//  - display user contributed photos in a map
//
//  This program is free software; you can redistribute it and/or modify it under
//  the terms of the GNU General Public License as published by the Free
//  Software Foundation; either version 2 of the License, or (at your option)
//  any later version.
//
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
//  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
//  more details.
//
//  You should have received a copy of the GNU General Public License along with
//  this program; if not, write to the Free Software Foundation, Inc., 59 Temple
//  Place, Suite 330, Boston, MA 02111-1307 USA
//
//  **** END LICENSE BLOCK ****


// our transaction object(s)
function Callback(target, targetFunction, args) {
   this.init(target, targetFunction, args);
}

Callback.prototype = {
   init : function(target, targetFunction, args) {
      this.target = target;
      this.targetFunction = targetFunction;
      this.args = args;
      if (!this.args) {
         this.args = [];
      }
   },

   execute : function() {
      var args = this.args.concat([]);
      // can't use concat on arguments because it's not an array...
      for (var i = 0; i < arguments.length; i++) {
         args.push(arguments[i]);
      }
      return this.targetFunction.apply(this.target, args);
   }
};
